#INCLUDE<P16F84A.INC>
;


#define canal1 PORTA,0
#define canal2 PORTA,1
#define ir_in  PORTA
#define led1 PORTB,1
#define led2 PORTB,2
#define led3 PORTB,3
#define led4 PORTB,4
#define led5 PORTB,5
#define leds PORTB
;
countcycl   equ 0x0C; 
countpower1  equ 0x0D;  1
byte0       equ 0x0E;1-  ( 7,6=0)
byte1       equ 0x0F;2-  
temp0       equ 0x11;
status_copy equ 0x12
temp1       equ 0x13
countpower2 equ 0x14;  2
count1      equ 0x15;
w_copy      equ 0x16
FSR_copy    equ 0x17
user        equ 0x18
flag        equ 0x19; 
                    ;  ( 0-  =1 ,   )
                    ;/  (1- =1 , 1 )  
                    ;/  (2- =1 , 2 )  
                    ;  (3- =1 ,    )
                    ;  (4- =1 ,    )
countdel    equ 0x1A
SB1         equ 0x1B;  / 1
user1       equ 0x1C;
SB2         equ 0x1D;  / 2
EADR        equ 0x1E;
SB3         equ 0x10;   
EDATA       equ 0x1F;
SB4         equ 0x20;   
r4          equ 0x21;
countdel1   equ 0x22;
r21         equ 0x23;
r22         equ 0x24;
r23         equ 0x25;
r24          equ 0x26;
r25          equ 0x2E;
r26   equ 0x27;
r27         equ 0x28;
r28        equ 0x29
r29       equ 0x2A 
r30    equ 0x2B
r31      equ 0x2C
r32       equ 0x2D
r33          equ 0x2E
r34          equ 0x2F



 org 0x0000
 goto start

 org 0x0004
int    goto puls 

 org 0x0005
start  ;   
       bcf STATUS,RP0
       bcf STATUS,RP1
       movlw B'00011100'
       movwf PORTA
       movlw B'10000000'
       movwf  PORTB
       bsf STATUS,RP0
       movlw B'10000001'
       movwf TRISB
       movlw B'00011100'
       movwf TRISA
       movlw B'01000111';   
                        ;  RB0, TMR0=256  
       movwf OPTION_REG
       bcf STATUS,RP0
       movlw B'10010000';  .  RB0 
       movwf INTCON
       clrf countcycl
       clrf countpower1;    =0%
       movlw 0x64
       movwf countpower2;    =100%

       ;     eeprom
       clrf EADR
       call READeeprom
       movwf SB1
       incf EADR
       call READeeprom
       movwf SB2
       incf EADR  
       call READeeprom
       movwf SB3
       incf EADR
       call READeeprom
       movwf SB4 
rest   clrf flag
       bsf flag,3;   
       bsf led3      
     
m1     ;   
       movf PORTB,w
       movwf user
       btfss user,7
       goto progr
       ; 
       call input_RC5
       btfss flag,0
       goto m1
       movf byte0,w
       xorwf SB1,w
       btfsc STATUS,Z
       goto chek1
       movf byte0,w
       xorwf SB2,w
       btfsc STATUS,Z
       goto chek2
       movf byte0,w
       xorwf SB3,w
       btfsc STATUS,Z
       goto UP
       movf byte0,w
       xorwf SB4,w
       btfsc STATUS,Z
       goto DOWN
       goto m1;,  


chek1
       call bigdel; 0,5 
       call bigdel; 0,5 
       call input_RC5; 
       btfss flag,0
       goto shift1;    
       call bigdel; 0,5 
       call bigdel; 0,5 
       call input_RC5; 
       movf byte0,w
       xorwf SB1,w
       btfss STATUS,Z
       goto shift1
       btfsc flag,1
       bcf canal1;  1
       movlw B'00000010'
       xorwf flag;  / 1
       movlw B'00000010'
       xorwf leds
       goto m1
shift1 bsf flag,3;   
       bcf flag,4
       bsf led3
       bcf led4 
       goto m1

 
chek2
       call bigdel; 0,5 
       call bigdel; 0,5 
       call input_RC5; 
       btfss flag,0
       goto shift2;    
       call bigdel; 0,5 
       call bigdel; 0,5 
       call input_RC5; 
       movf byte0,w
       xorwf SB2,w
       btfss STATUS,Z
       goto shift2
       btfsc flag,2
       bcf canal2;  2
       movlw B'00000100'
       xorwf flag;  / 2
       movlw B'00000100'
       xorwf leds
       goto m1
shift2 bsf flag,4;   
       bcf flag,3
       bsf led4
       bcf led3 
       goto m1      


UP
       call bigdel; 0,5 
       call input_RC5; 
       movf byte0,w
       xorwf SB3,w
       btfss STATUS,Z
       goto m1
       btfss flag,3
       goto pow2;   
       movf countpower1,w;   
       xorlw 0x64
       btfsc STATUS,Z
       goto UP; , countpower1=100
       incf countpower1
       goto UP

pow2   movf countpower2,w;
       xorlw 0x64
       btfsc STATUS,Z
       goto UP; , countpower2=100
       incf countpower2
       goto UP

      
DOWN
       call bigdel; 0,5 
       call input_RC5; 
       movf byte0,w
       xorwf SB4,w
       btfss STATUS,Z
       goto m1
       btfss flag,3
       goto pow3;   
       movf countpower1,w;   
       xorlw 0x00
       btfsc STATUS,Z
       goto DOWN; , countpower1=0
       decf countpower1
       goto DOWN

pow3   movf countpower2,w;
       xorlw 0x00
       btfsc STATUS,Z
       goto DOWN; , countpower2=0
       decf countpower2
       goto DOWN     

progr  clrf leds   
       bsf led5
       bsf led1
       clrf EADR
       ;   / 1
c1     call input_RC5
        btfss flag,0
        goto c1
       movf byte0,w
       movwf user1
       call bigdel
       call input_RC5; 
       movf byte0,w
       xorwf user1
       btfss STATUS,Z
       goto c1
       movwf SB1
       movwf EDATA
       call WRITEeeprom;   SB1  eeprom
       call bigdel
       bcf led1
       call bigdel
       bsf led2
       ;   / 2
c2     call input_RC5
        btfss flag,0
        goto c2
       movf byte0,w
       movwf user1
       call bigdel
       call input_RC5; 
       movf byte0,w
       xorwf user1
       btfss STATUS,Z
       goto c2
       movwf SB2
       movwf EDATA
       incf EADR
       call WRITEeeprom;   SB2  eeprom
       call bigdel
       bcf led2
       call bigdel
       bsf led3
       ;    
c3     call input_RC5
        btfss flag,0
        goto c3
       movf byte0,w
       movwf user1
       call bigdel
       call input_RC5; 
       movf byte0,w
       xorwf user1
       btfss STATUS,Z
       goto c3
       movwf SB3
       movwf EDATA
       incf EADR
       call WRITEeeprom;   SB3  eeprom
       call bigdel
       bcf led3
       call bigdel
       bsf led4
       ;    
c4     call input_RC5
        btfss flag,0
        goto c4 
       movf byte0,w
       movwf user1
       call bigdel
       call input_RC5; 
       movf byte0,w
       xorwf user1
       btfss STATUS,Z
       goto c4
       movwf SB4
       movwf EDATA
       incf EADR
       call WRITEeeprom;   SB4  eeprom
       call bigdel
       bcf led4
       ; "" 3  
       call bigdel
       bcf led5
       call bigdel
       bsf led5
       call bigdel
       bcf led5    
       call bigdel
       bsf led5
       call bigdel
       bcf led5   
       goto rest
 
       
puls   ;/     
       ;   
       movwf w_copy; 
       movf STATUS,w
       movwf status_copy
       movf FSR,w
       movwf FSR_copy

       incf countcycl; .
       movf countcycl,w
       xorlw 0x65
       btfsc STATUS,Z
       clrf countcycl;countcycl=0,  =101
       btfss flag,1;  / 1
       goto next1 
       movf countpower1,w
       xorlw 0x00;.1=0 ?
       btfss STATUS,Z
       goto loop0
       bcf canal1        
       goto next1
loop0  movf countpower1,w
       xorlw 0x64;.1=100 ?
       btfss STATUS,Z
       goto loop1
       bsf canal1
       goto next1
loop1  movf countpower1,w
       subwf countcycl,w;(..)-(..1)
       btfsc STATUS,C
       goto $+3
       bsf canal1;(..)-(..1)<0
       goto next1
       btfss STATUS,Z
       goto $+3
       bsf canal1;(..)-(..1)=0    
       goto next1
       bcf canal1;(..)-(..1)>0

next1  btfss flag,2;  / 2
       goto next2 
       movf countpower2,w
       xorlw 0x00;.2=0 ?
       btfss STATUS,Z
       goto loop2
       bcf canal2        
       goto next2
loop2  movf countpower2,w
       xorlw 0x64;.2=100 ?
       btfss STATUS,Z
       goto loop3
       bsf canal2
       goto next2
loop3  movf countpower2,w
       subwf countcycl,w;(..)-(..2)
       btfsc STATUS,C
       goto $+3
       bsf canal2;(..)-(..2)<0
       goto next2
       btfss STATUS,Z
       goto $+3
       bsf canal2;(..)-(..2)=0    
       goto next2
       bcf canal2;(..)-(..2)>0   

next2  ; 
       movf FSR_copy,w
       movwf FSR
       movf status_copy,w
       movwf STATUS
       swapf w_copy,f
       swapf w_copy,w
       bcf INTCON,INTF
       retfie



input_RC5 ;/     (RC5).   130 
                 
       bcf flag,0
       clrf byte0
       clrf byte1
       movlw D'14'
       movwf count1

       movlw 0x02
       movwf countdel1
opros  bcf INTCON,T0IF
       clrf TMR0
       movf ir_in,w; 
       movwf user
       btfsc user,3
       goto esc0;,                         
       call del300
       movf ir_in,w; 
       movwf user
       btfsc user,3
       goto esc0;,  
loop5  movf ir_in,w
       andlw B'00001000'
       xorlw B'00001000'; 
       movwf user       
       rrf user
       rrf user
       rrf user
       rrf user;  -   
       rlf byte0
       rlf byte1
       call del1763 
       decfsz count1
       goto loop5
       bsf flag,0
       goto esc2
esc0   btfss INTCON,T0IF
       goto opros+2
       decfsz countdel1
       goto opros
esc2   return 

        

del300 ; 300 
       movlw 0x4A
       movwf countdel
cycl1  nop
       decfsz countdel
       goto cycl1
       return


del1763 ; 1763 (1768-15=1763)
       movlw 0xFB
       movwf countdel
cycl2  goto $+1
       goto $+1
       decfsz countdel
       goto cycl2
       return   

bigdel ; 0,5 
       movlw 0x07
       movwf countdel1
loop7  clrf TMR0
loop6  btfss INTCON,T0IF
       goto loop6
       bcf INTCON,T0IF
       decfsz countdel1
       goto loop7
       return

READeeprom
   movf EADR,w
   movwf EEADR
   bsf STATUS,RP0; 1
   bsf EECON1,RD;
   bcf STATUS,RP0; 0
   movf EEDATA,w
   return

WRITEeeprom
   bsf STATUS,RP0; 1
   btfsc EECON1,WR
   goto $-1
   bcf STATUS,RP0; 0
   movf EADR,w
   movwf EEADR
   movf EDATA,w
   movwf EEDATA
   bsf STATUS,RP0; 1
   bsf EECON1,WREN
   bcf INTCON,GIE
   movlw 0x55
   movwf EECON2
   movlw 0xAA
   movwf EECON2
   bsf EECON1,WR
   bsf INTCON,GIE
   bcf EECON1,WREN
   bcf STATUS,RP0; 0
   return 
        
 end     


